"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _widgetHelpers = require("./util/widgetHelpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

const propTypes = {
  className: _propTypes.default.string,
  role: _propTypes.default.string,
  emptyListMessage: _propTypes.default.node
};

const Listbox = _react.default.forwardRef((_ref, ref) => {
  let {
    className,
    role,
    multiple,
    children,
    emptyListMessage
  } = _ref,
      props = _objectWithoutProperties(_ref, ["className", "role", "multiple", "children", "emptyListMessage"]);

  const id = (0, _widgetHelpers.useInstanceId)();
  return _react.default.createElement("div", Object.assign({
    id: id,
    ref: ref,
    tabIndex: 0,
    "aria-multiselectable": !!multiple,
    className: (0, _classnames.default)(className, 'rw-list'),
    role: role === undefined ? 'listbox' : role
  }, props), _react.default.Children.count(children) ? children : _react.default.createElement("div", {
    className: "rw-list-empty"
  }, emptyListMessage));
});

Listbox.displayName = 'BaseListbox';
Listbox.propTypes = propTypes;
var _default = Listbox;
exports.default = _default;