import React from 'react';
import { DataItem } from './types';
import { TextAccessorFn } from './util/dataHelpers';
declare type ListOptionContext = {
    options: unknown[];
};
export declare const OptionsContext: React.Context<ListOptionContext | null>;
export declare function getList(options: DataItem[], textAccessor: TextAccessorFn, disabledItems: DataItem[]): {
    first: () => any;
    last: () => any;
    prev(item: any, word?: string | undefined): any;
    next(item: any, word?: string | undefined): any;
    nextEnabled: (item: any) => any;
};
export declare function useOptionList(textAccessor: TextAccessorFn, disabledItems: DataItem[]): readonly [{
    options: object[];
}, {
    first: () => any;
    last: () => any;
    prev(item: any, word?: string | undefined): any;
    next(item: any, word?: string | undefined): any;
    nextEnabled: (item: any) => any;
}];
export declare function useClearListOptions(providedContext?: ListOptionContext): void;
export declare function useListOption(dataItem: unknown): void;
export {};
//# sourceMappingURL=ListboxContext.d.ts.map