import React, { ReactNode } from 'react';
import { MultiselectTagProps } from './MultiselectTag';
import { RenderProp } from './types';
import { DataKeyAccessorFn, TextAccessorFn } from './util/dataHelpers';
export declare type RenderTagProp<TDataItem> = RenderProp<{
    item: TDataItem;
}>;
export declare type TagComponentProp = React.ComponentType<MultiselectTagProps>;
interface MultiselectTagListProps<TDataItem> {
    id: string;
    activeId: string;
    label?: string;
    value: TDataItem[];
    focusedItem?: TDataItem;
    clearTagIcon: React.ReactNode;
    dataKeyAccessor: DataKeyAccessorFn;
    textAccessor: TextAccessorFn;
    onDelete: (dataItem: TDataItem, event: React.MouseEvent<HTMLButtonElement>) => void;
    renderTagValue?: RenderTagProp<TDataItem>;
    tagOptionComponent?: TagComponentProp;
    disabled?: TDataItem[];
    children?: ReactNode;
}
declare function MultiselectTagList<TDataItem>({ id, value, activeId, dataKeyAccessor, textAccessor, label, disabled, onDelete, focusedItem, children, clearTagIcon, renderTagValue, tagOptionComponent: TagOption, }: MultiselectTagListProps<TDataItem>): JSX.Element;
export default MultiselectTagList;
//# sourceMappingURL=MultiselectTagList.d.ts.map