/// <reference types="react" />
import PropTypes from 'prop-types';
declare function TimeInput(uncontrolledProps: any): JSX.Element;
declare namespace TimeInput {
    var propTypes: {
        value: PropTypes.Requireable<Date>;
        onChange: PropTypes.Requireable<(...args: any[]) => any>;
        /**
         * The default date used to construct a new time when the `value` is empty
         *
         * @default new Date()
         **/
        datePart: PropTypes.Requireable<Date>;
        /**
         * Use a 12 hour clock (with AM/PM) instead of 24 hour one.
         * The configured localizer may provide a default value .
         **/
        use12HourClock: PropTypes.Requireable<boolean>;
        /** Time part values will be padded by `0` */
        padValues: PropTypes.Requireable<boolean>;
        /** The string character used to pad empty, or cleared values */
        emptyCharacter: PropTypes.Requireable<string>;
        /** Hide the input clear button */
        noClearButton: PropTypes.Requireable<boolean>;
        disabled: PropTypes.Requireable<boolean>;
        readOnly: PropTypes.Requireable<boolean>;
        /** Controls how precise of a time can be input **/
        precision: PropTypes.Validator<string>;
        /**
         * The seperator between hours and minutes
         * @default ':'
         */
        hoursAddon: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /**
         * The seperator between hours and minutes
         * @default ':'
         */
        minutesAddon: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /**
         * The seperator between hours and minutes
         * @default ':'
         */
        secondsAddon: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /**
         * The seperator between hours and minutes
         * @default '.'
         */
        millisecondsAddon: PropTypes.Requireable<PropTypes.ReactNodeLike>;
    };
    var defaultProps: {
        hoursAddon: string;
        padValues: boolean;
        precision: string;
        emptyCharacter: string;
    };
}
export default TimeInput;
//# sourceMappingURL=TimeInput.d.ts.map