import PropTypes from 'prop-types';
import { TextAccessor } from './dataHelpers';
export declare const presets: {
    eq: (a: any, b: any) => boolean;
    contains: (a: string, b: string) => boolean;
    startsWith: (a: string, b: string) => boolean;
};
export declare type FilterFunction<TDataItem> = (item: TDataItem, searchTerm: string, idx?: number) => boolean;
export declare type FilterPreset = keyof typeof presets;
export declare type Filter<TDataItem> = boolean | FilterPreset | FilterFunction<TDataItem> | null;
export declare const propTypes: {
    textField: any;
    filter: PropTypes.Requireable<string | boolean | ((...args: any[]) => any)>;
};
interface FilterOptions<TDataItem> {
    filter: Filter<TDataItem>;
    searchTerm?: string;
    textField?: TextAccessor;
}
export declare function filter<TDataItem>(data: TDataItem[], { searchTerm, ...options }: FilterOptions<TDataItem>): TDataItem[];
export {};
//# sourceMappingURL=Filter.d.ts.map