"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.valueMatcher = valueMatcher;
exports.dataIndexOf = dataIndexOf;
exports.dataItem = dataItem;
exports.dataText = exports.dataValue = void 0;

var _ = require("./_");

const dataValue = (dataItem, field) => {
  if (typeof field === 'function') return field(dataItem);
  if (dataItem == null) return dataItem;
  if (typeof field === 'string' && typeof dataItem === 'object' && field in dataItem) return dataItem[field];
  return dataItem;
};

exports.dataValue = dataValue;

const dataText = (dataItem, textField) => {
  const value = dataValue(dataItem, textField);
  return value == null ? '' : String(value);
};
/**
 * I don't know that the shallow equal makes sense here but am too afraid to
 * remove it.
 */


exports.dataText = dataText;

function valueMatcher(a, b, dataKey) {
  return (0, _.isShallowEqual)(dataValue(a, dataKey), dataValue(b, dataKey));
}

function dataIndexOf(data, value, dataKey) {
  let idx = -1;

  while (++idx < data.length) {
    const datum = data[idx];
    if (datum === value || valueMatcher(value, datum, dataKey)) return idx;
  }

  return -1;
}

function dataItem(data, value, dataKey) {
  const idx = dataIndexOf(data, value, dataKey); // This isn't strictly safe, but we want to allow items that aren't in the list

  return idx !== -1 ? data[idx] : value;
}